

   MEMBER('embeds.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EMBEDS005.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Select a EmbedProc Record
!!! </summary>
SelectEmbedProc PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(EmbedProc)
                       PROJECT(EMP:EmbedProcID)
                       PROJECT(EMP:EmbedAppID)
                       PROJECT(EMP:Proc)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
EMP:EmbedProcID        LIKE(EMP:EmbedProcID)          !List box control field - type derived from field
EMP:EmbedAppID         LIKE(EMP:EmbedAppID)           !List box control field - type derived from field
EMP:Proc               LIKE(EMP:Proc)                 !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a EmbedProc Record'),AT(,,216,198),FONT('MS Sans Serif',8,,FONT:regular),RESIZE, |
  CENTER,GRAY,IMM,MDI,HLP('SelectEmbedProc'),SYSTEM
                       LIST,AT(8,30,200,124),USE(?Browse:1),HVSCROLL,FORMAT('64R(2)|M~Embed Proc ID~C(0)@n-14@' & |
  '64R(2)|M~Embed App ID~C(0)@n-14@80L(2)|M~Proc~L(2)@s60@'),FROM(Queue:Browse:1),IMM,MSG('Browsing t' & |
  'he EmbedProc file')
                       BUTTON('&Select'),AT(159,158,49,14),USE(?Select:2),LEFT,ICON('WASELECT.ICO'),FLAT,MSG('Select the Record'), |
  TIP('Select the Record')
                       SHEET,AT(4,4,208,172),USE(?CurrentTab)
                         TAB('&1) PRIMARY'),USE(?Tab:2)
                         END
                         TAB('&2) EmbedAppIDIndex'),USE(?Tab:3)
                         END
                       END
                       BUTTON('&Close'),AT(110,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(163,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
Previous               PROCEDURE(),BYTE,DERIVED
PrimeRecord            PROCEDURE(BYTE SuppressClear = 0),BYTE,PROC,DERIVED
Reset                  PROCEDURE(),DERIVED
Reset                  PROCEDURE(BYTE Locate),DERIVED
ResetFromAsk           PROCEDURE(*BYTE Request,*BYTE Response),DERIVED
ResetFromBuffer        PROCEDURE(),DERIVED
ResetFromFile          PROCEDURE(),DERIVED
ResetFromView          PROCEDURE(),DERIVED
ResetQueue             PROCEDURE(BYTE ResetMode),DERIVED
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
RestoreBuffers         PROCEDURE(),DERIVED
SaveBuffers            PROCEDURE(),DERIVED
ScrollEnd              PROCEDURE(SIGNED Event),DERIVED
ScrollOne              PROCEDURE(SIGNED Event),DERIVED
ScrollPage             PROCEDURE(SIGNED Event),DERIVED
SetAlerts              PROCEDURE(),DERIVED
SetFilter              PROCEDURE(STRING Filter),DERIVED
SetFilter              PROCEDURE(STRING Filter,STRING Id),DERIVED
SetOrder               PROCEDURE(STRING Order),DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectEmbedProc')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:EmbedProc.Open                                    ! File EmbedProc used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:EmbedProc,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,EMP:EmbedAppIDIndex)                  ! Add the sort order for EMP:EmbedAppIDIndex for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,EMP:EmbedAppID,,BRW1)          ! Initialize the browse locator using  using key: EMP:EmbedAppIDIndex , EMP:EmbedAppID
  BRW1.AddSortOrder(,EMP:PRIMARY)                          ! Add the sort order for EMP:PRIMARY for sort order 2
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort0:Locator.Init(,EMP:EmbedProcID,,BRW1)         ! Initialize the browse locator using  using key: EMP:PRIMARY , EMP:EmbedProcID
  BRW1.AddField(EMP:EmbedProcID,BRW1.Q.EMP:EmbedProcID)    ! Field EMP:EmbedProcID is a hot field or requires assignment from browse
  BRW1.AddField(EMP:EmbedAppID,BRW1.Q.EMP:EmbedAppID)      ! Field EMP:EmbedAppID is a hot field or requires assignment from browse
  BRW1.AddField(EMP:Proc,BRW1.Q.EMP:Proc)                  ! Field EMP:Proc is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectEmbedProc',QuickWindow)              ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EmbedProc.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectEmbedProc',QuickWindow)           ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeFieldEvent()
  CASE FIELD()
  OF ?CurrentTab
    CASE EVENT()
!EMBED
    OF EVENT:TabChanging
!EMBED
    ELSE
!EMBED
    END
!EMBED
  OF ?Tab:2
!EMBED
    CASE EVENT()
!EMBED
    ELSE
!EMBED
    END
!EMBED
  END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


BRW1.Previous PROCEDURE

ReturnValue          BYTE,AUTO

!EMBED
  CODE
!EMBED
  ReturnValue = PARENT.Previous()
!EMBED
  RETURN ReturnValue


BRW1.PrimeRecord PROCEDURE(BYTE SuppressClear = 0)

ReturnValue          BYTE,AUTO

!EMBED
  CODE
!EMBED
  ReturnValue = PARENT.PrimeRecord(SuppressClear)
!EMBED
  RETURN ReturnValue


BRW1.Reset PROCEDURE

!EMBED
  CODE
!EMBED
  PARENT.Reset
!EMBED


BRW1.Reset PROCEDURE(BYTE Locate)

!EMBED
  CODE
!EMBED
  PARENT.Reset(Locate)
!EMBED


BRW1.ResetFromAsk PROCEDURE(*BYTE Request,*BYTE Response)

!EMBED
  CODE
!EMBED
  PARENT.ResetFromAsk(Request,Response)
!EMBED


BRW1.ResetFromBuffer PROCEDURE

!EMBED
  CODE
!EMBED
  PARENT.ResetFromBuffer
!EMBED


BRW1.ResetFromFile PROCEDURE

!EMBED
  CODE
!EMBED
  PARENT.ResetFromFile
!EMBED


BRW1.ResetFromView PROCEDURE

!EMBED
  CODE
!EMBED
  SETCURSOR(Cursor:Wait)
  Relate:EmbedProc.SetQuickScan(1)
  SELF.Reset
!EMBED
  IF SELF.UseMRP
     IF SELF.View{PROP:IPRequestCount} = 0
          SELF.View{PROP:IPRequestCount} = 60
     END
  END
  LOOP
    IF SELF.UseMRP
       IF SELF.View{PROP:IPRequestCount} = 0
            SELF.View{PROP:IPRequestCount} = 60
       END
    END
    CASE SELF.Next()
    OF Level:Notify
      BREAK
    OF Level:Fatal
      SETCURSOR()
      RETURN
    END
!EMBED
    SELF.SetQueueRecord
!EMBED
  END
  SELF.View{PROP:IPRequestCount} = 0
!EMBED
  PARENT.ResetFromView
!EMBED
  Relate:EmbedProc.SetQuickScan(0)
  SETCURSOR()
!EMBED


BRW1.ResetQueue PROCEDURE(BYTE ResetMode)

!EMBED
  CODE
!EMBED
  PARENT.ResetQueue(ResetMode)
!EMBED


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

!EMBED
  CODE
!EMBED
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
!EMBED
  ReturnValue = PARENT.ResetSort(Force)
!EMBED
  RETURN ReturnValue


BRW1.RestoreBuffers PROCEDURE

!EMBED
  CODE
!EMBED
  PARENT.RestoreBuffers
!EMBED


BRW1.SaveBuffers PROCEDURE

!EMBED
  CODE
!EMBED
  PARENT.SaveBuffers
!EMBED


BRW1.ScrollEnd PROCEDURE(SIGNED Event)

!EMBED
  CODE
!EMBED
  PARENT.ScrollEnd(Event)
!EMBED


BRW1.ScrollOne PROCEDURE(SIGNED Event)

!EMBED
  CODE
!EMBED
  PARENT.ScrollOne(Event)
!EMBED


BRW1.ScrollPage PROCEDURE(SIGNED Event)

!EMBED
  CODE
!EMBED
  PARENT.ScrollPage(Event)
!EMBED


BRW1.SetAlerts PROCEDURE

!EMBED
  CODE
!EMBED
  PARENT.SetAlerts
!EMBED


BRW1.SetFilter PROCEDURE(STRING Filter)

!EMBED
  CODE
!EMBED
  PARENT.SetFilter(Filter)
!EMBED


BRW1.SetFilter PROCEDURE(STRING Filter,STRING Id)

!EMBED
  CODE
!EMBED
  PARENT.SetFilter(Filter,Id)
!EMBED


BRW1.SetOrder PROCEDURE(STRING Order)

!EMBED
  CODE
!EMBED
  PARENT.SetOrder(Order)
!EMBED


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

